"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = void 0;
const test_1 = require("@xstate/test");
const Array_1 = require("fp-ts/lib/Array");
const function_1 = require("fp-ts/lib/function");
const d = __importStar(require("io-ts/lib/Decoder"));
const xstate_1 = require("xstate");
const pageFnDecoder = () => ({
    decode: (fn) => typeof fn === "function"
        ? d.success(fn)
        : d.failure(fn, "is not a function"),
});
const decoderDelay = d.tuple(d.union(d.literal("delay"), d.literal("wait"), d.literal("...")), d.number);
const decoderResolve = d.tuple(d.literal("resolve"), d.union(d.string, d.array(d.string)));
const decoderWaitForFocus = d.tuple(d.union(d.literal("waitForFocus"), d.literal("$:focus")), d.string);
const decoderExpectProperty = d.tuple(d.union(d.literal("expectProperty"), d.literal("prop"), d.literal(".")), d.string, d.string, d.union(d.number, d.string, d.boolean));
const decoderSelect = d.tuple(d.literal("select"), d.string, d.union(d.string, d.number, d.array(d.union(d.string, d.number))));
const decoderType = d.tuple(d.literal("type"), d.string, d.union(d.string, d.number));
const decoderWaitForSelector = d.tuple(d.union(d.literal("waitForSelector"), d.literal("$")), d.union(d.string, d.array(d.string)));
const decoderClick = d.tuple(d.literal("click"), d.union(d.string, d.array(d.string)));
const decoderDefer = d.tuple(d.literal("defer"), d.union(d.string, d.array(d.string)));
const actionDecoder = () => d.union(decoderDelay, pageFnDecoder(), decoderResolve, decoderWaitForFocus, decoderExpectProperty, decoderDefer, decoderClick, decoderWaitForSelector, decoderSelect, decoderType);
const valueDecoder = d.nullable(d.union(d.string, d.number, d.boolean));
const jsonDecoder = d.lazy("JSON", () => d.union(valueDecoder, d.array(jsonDecoder), d.record(jsonDecoder)));
// const configDecoder = <TTestContext>() => {
const configDecoder = () => {
    const decoderInstructions = d.union(pageFnDecoder(), d.array(actionDecoder()));
    return d.intersect(d.partial({
        plan: d.union(d.number, d.tuple(d.number, d.number)),
        coverage: d.boolean,
        simple: d.boolean,
        beforeVisit: decoderInstructions,
        apis: d.array(d.intersect(d.type({ path: d.string }))(d.partial({
            deferrals: d.array(d.string),
            outcomes: d.record(d.partial({
                status: d.number,
                body: jsonDecoder,
            })),
        }))),
        viewport: d.type({
            width: d.number,
            height: d.number,
        }),
    }))(d.type({
        id: d.string,
        visit: d.intersect(d.type({ path: d.string }))(d.partial({
            port: d.number,
            server: d.string,
        })),
        initial: d.string,
        states: d.record(d.partial({
            type: d.literal("final"),
            tests: decoderInstructions,
            on: d.record(d.union(d.string, decoderInstructions, d.partial({
                target: d.string,
                actions: decoderInstructions,
            }))),
        })),
    }));
};
const bar = configDecoder();
class _ {
    constructor() {
        this.Action = actionDecoder();
        this.Configuration = configDecoder();
    }
}
exports.default = (json) => configDecoder().decode(json);
const defaultSelectorWrapper = (selector) => `[data-testid~="${selector}"]`;
const defaultPorts = {
    ci: 7777,
    prod: 7777,
    dev: 3000,
};
const make = (actionsParser) => (withPlans) => ({ selectorWrapper = defaultSelectorWrapper, ports: ports_ = defaultPorts, server = "http://localhost", xstateInspect = false, } = {
    selectorWrapper: defaultSelectorWrapper,
    ports: defaultPorts,
    server: "http://localhost",
    xstateInspect: false,
}) => {
    const ports = Object.assign(Object.assign({}, defaultPorts), ports_);
    const ci = process.env.CI === "true";
    const prod = process.env.NODE_ENV === "production";
    const port = ci && ports.ci ? ports.ci : ci || prod ? ports.ci || ports.prod : ports.dev;
    return (configuration) => {
        const eitherConfig = configDecoder().decode(configuration);
        if (eitherConfig._tag === "Right") {
            const config = eitherConfig.right;
            const machineTemplate = {
                id: config.id,
                initial: config.initial,
                states: {},
                describe: {},
            };
            const eventMap = {};
            Object.keys(config.states).forEach((state) => {
                const { type, tests, on: events = {} } = config.states[state];
                const meta = tests && {
                    test: (testContext, _state) => {
                        return typeof tests === "function"
                            ? tests(testContext)
                            : actionsParser(selectorWrapper)(buffer)(tests)(testContext);
                    },
                };
                const on = Object.keys(events || {}).reduce((acc, eventType) => {
                    const event = events[eventType];
                    const actions = typeof event === "string"
                        ? []
                        : typeof event === "function"
                            ? [event]
                            : Array.isArray(event)
                                ? event
                                : !event.actions
                                    ? []
                                    : typeof event.actions === "function"
                                        ? [event.actions]
                                        : event.actions;
                    const target = typeof event === "string"
                        ? event
                        : typeof event !== "function" && !Array.isArray(event)
                            ? event.target
                            : undefined;
                    acc[eventType] = target
                        ? {
                            target,
                        }
                        : {};
                    eventMap[eventType] = {
                        exec: (testContext) => actionsParser(selectorWrapper)(buffer)(actions)(testContext),
                    };
                    return acc;
                }, {});
                const stateNode = Object.assign({
                    meta,
                    on,
                    type,
                });
                machineTemplate.states[state] = stateNode;
            });
            const machine = xstate_1.createMachine(machineTemplate);
            const buffer = [];
            const pattern = [];
            const model = test_1.createModel(machine).withEvents(eventMap);
            const plans = config.simple ? model.getSimplePathPlans() : model.getShortestPathPlans();
            const visitPath = /^\//.test(config.visit.path)
                ? config.visit.path
                : `/${config.visit.path}`;
            const q = /\?/.test(visitPath) ? "&" : "?";
            const url = `${server}:${port}${visitPath}${q}xstate-inspect=${xstateInspect}`;
            const outcomes = function_1.pipe(config.apis || [], Array_1.chain((api) => Object.keys(api.outcomes || {})));
            withPlans({
                model,
                plans: !config.plan
                    ? plans
                    : Array.isArray(config.plan)
                        ? plans.slice(...config.plan)
                        : plans.slice(config.plan, config.plan + 1),
                buffer,
                pattern,
                url,
                config,
                outcomes,
                selectorWrapper,
            });
        }
    };
};
exports.make = make;
