"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.delay = exports.defer = void 0;
const defer = (value, id) => {
    let resolve = () => {
        throw Error("Unexpected deferral");
    };
    const promise = new Promise((r) => {
        resolve = () => r(value);
    });
    return Object.assign(promise, { resolve, id });
};
exports.defer = defer;
const delay = (milliseconds = 1000) => new Promise((resolve) => setTimeout(resolve, milliseconds));
exports.delay = delay;
